/*
 * @file:    UartDev_STM32.h
 * @purpose: USART Serial Device Definitions for STM32
 * @version: V1.11
 * @date:    14. Apr. 2009
 *----------------------------------------------------------------------------
 *
 * Copyright (C) 2009 ARM Limited. All rights reserved.
 *
 * ARM Limited (ARM) is supplying this software for use with Cortex-Mx 
 * processor based microcontrollers.  This file can be freely distributed
 * within development tools that are supporting such ARM based processors.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * ARM SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 */

#ifndef __UARTDEV_STM32_H
#define __UARTDEV_STM32_H


/*----------------------------------------------------------------------------
 Define  Baudrate setting (BRR) for USART 
 *----------------------------------------------------------------------------*/
#define __DIV(_PCLK_, _BAUD_)       ((_PCLK_*25)/(4*_BAUD_))
#define __DIVMANT(_PCLK_, _BAUD_)   (__DIV(_PCLK_, _BAUD_)/100)
#define __DIVFRAQ(_PCLK_, _BAUD_)   (((__DIV(_PCLK_, _BAUD_) - (__DIVMANT(_PCLK_, _BAUD_) * 100)) * 16 + 50) / 100)
#define __USART_BRR(_PCLK_, _BAUD_) ((__DIVMANT(_PCLK_, _BAUD_) << 4)|(__DIVFRAQ(_PCLK_, _BAUD_) & 0x0F))


#endif

/*----------------------------------------------------------------------------
 * end of file
 *---------------------------------------------------------------------------*/

