/*
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/* Old Example program that can echos data from usart1 or using int sends A and B. Also uses Tim1 to toogle LED through an int.
 */
 
#include "main.h"
#include <stdbool.h>

void usart1_irq_handler(void) {
  usart_transmit_complete_flag(USART1);
  static bool toggle=false;
  if (toggle) {
    usart_data_write(USART1,'A');
    toggle=true;
  } else {
    usart_data_write(USART1,'B');
    toggle=false;
  }
}

void tim1_cc_irq_handler(void) {
  tim_cc_int_flag_clr(TIM1,TIM_CHANNEL1);
  static int toggle=0;
  if (toggle==0) {
    gpio_reset_pins(GPIOC,GPIO_Pin_12);
      //tim_force_update_event(TIM1);
      //tim_clock_enable(TIM1);
      //gpio_reset_pins(GPIOC,GPIO_Pin_2);
      //gpio_reset_pins(GPIOA,GPIO_Pin_8);
      toggle=1;
  } else {
    gpio_set_pins(GPIOC,GPIO_Pin_12);
    //gpio_set_pins(GPIOC,GPIO_Pin_2);
    //gpio_set_pins(GPIOA,GPIO_Pin_8);
    toggle=0;
  }
}

void usart_init(void) {
  usart_enable(USART1);
  usart_word_len_set(USART1,USART_8_N);
  usart_stop_bits_set(USART1,USART_1_STOP);
  usart_transmit_complete_int_disable(USART1);
  usart_receive_register_full_int_disable(USART1);
  usart_transmit_enable(USART1);
  //usart_baud_rate_set(USART1, 9600, 72000000);
  usart_usartdiv_set(USART1,364.583333);
  usart_receive_enable(USART1);
  //usart_baud_rate_write(USART1,468,12);
}

int main(void){
  //timer stuff

    //    hola_t tuanis=HOLA;
    //hola_t tuanis2=40;
    //osc_t hola=90;
    //gpio_mode_t mode;
    int A,C,D;
    int toggle=0;
    volatile float temp;
    temp=temp*12;
    CORE_disableGlobalFaultIRQ();
    CORE_disableGlobalIRQ();
    rcc_oscOff(PLL);
    (void) rcc_PLLFreqScaleSel(14);
    (void) rcc_PLLSourceSel(HSICLKDIV2);
    //rcc_oscOn(HSE);
    //while (rcc_is_oscReady(HSE));
    rcc_oscOn(PLL);
    while (rcc_is_oscReady(PLL));
    //rcc_oscOff(HSI);
    //rcc_HSITrimWrite(0);
    //rcc_oscOn(HSI);
    //while (rcc_is_oscReady(HSI));
    (void) rcc_SYSCLKSourceSel(PLLCLK);
    //Sysclk=56MHz
    (void) rcc_AHBPRESourceSel(SYSCLK);
    (void) rcc_APB1PRESourceSel(HCLKDIV2);
    (void) rcc_APB2PRESourceSel(HCLK);
    (void) rcc_ADCPRESourceSel(PLCLK2DIV2);
    (void) rcc_periClkEnable(IOPC);
    (void) rcc_periClkEnable(IOPA);
    (void) rcc_periClkEnable(RCC_TIM1); //56Mhz
    (void) rcc_periClkEnable(RCC_USART1); //56Mhz
    D=1;
    gpio_set_mode(GPIOC,GPIOM_OUT50_PP,GPIO_Pin_12|GPIO_Pin_2);
    gpio_set_mode(GPIOA,GPIOM_OUT50_ALT_PP,GPIO_Pin_8|GPIO_Pin_9);
    gpio_set_mode(GPIOA,GPIOM_IN_FL,GPIO_Pin_10);
    gpio_set_pins(GPIOC,GPIO_Pin_12);
    tim_test_output_compare_mode(TIM1, TIM_CHANNEL1);
    nvic_enable_irq(tim1_cc_irq_IRQn);
    nvic_enable_irq(usart1_irq_IRQn);
    usart_init();
    CORE_enableGlobalIRQ();
    CORE_enableGlobalFaultIRQ();
    usart_data_write(USART1,'A');
    while (!usart_transmit_complete_flag(USART1)) {
    }
    //tim_test_forced_output_mode(TIM1,TIM_CHANNEL1);
    //    gpio_set_mode(GPIOA,GPIOM_OUT2_PP,GPIO_Pin_8);
    unsigned char usart_data='A';
    while (true) {
      while (usart_receive_register_full_flag(USART1)) {
	  usart_data=usart_data_read(USART1);
	  usart_data_write(USART1,usart_data);
	  while (!usart_transmit_complete_flag(USART1)) {
	  }
      }
    }
    while (true) {
      usart_data_write(USART1,usart_data);
      while (!usart_transmit_complete_flag(USART1)) {
      }
    }
    while (true) {
        if (toggle==0) {
	  //usart_data_write(USART1,'A');
	  //gpio_reset_pins(GPIOC,GPIO_Pin_12);
	    //tim_force_update_event(TIM1);
	    //tim_clock_enable(TIM1);
	    //gpio_reset_pins(GPIOC,GPIO_Pin_2);
	    //gpio_reset_pins(GPIOA,GPIO_Pin_8);
            toggle=1;
        } else {
	  //usart_data_write(USART1,'B');
	  //gpio_set_pins(GPIOC,GPIO_Pin_12);
	    //gpio_set_pins(GPIOC,GPIO_Pin_2);
	    //gpio_set_pins(GPIOA,GPIO_Pin_8);
            toggle=0;
        }
        for(int i=0;i<4000;i++) {
            for (int j=0;j<200;j++) {
                A=i;
                C=A+D;
            }
        }
    }
    return(SUCCESS);
}
