/* 
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com> 
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 3 of the License, or 
 * (at your option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef AFIO_H
#define AFIO_H
#include "mem_map.h"
#include "types.h"
#include "utils.h"
#include <stdint.h>

typedef struct {
  __RW uint32_t EVCR;
  __RW uint32_t MAPR;
  __RW uint32_t EXTICR1;
  __RW uint32_t EXTICR2;
  __RW uint32_t EXTICR3;
  __RW uint32_t EXTICR4;
} afio_t;

#define AFIO ((afio_t *) AFIO_BASE)

/*Serial wire JTAG configuration*/
#define SWJ_CFG_shift_places 24
#define SWJ_CFG_bits (bit24|bit25|bit26)
#define SWJ_CFG_full_swj_reset_state 0x0
#define SWJ_CFG_full_swj_no_jntrst 0x1
#define SWJ_CFG_jtag_dp_dis_sw_dp_en 0x2
#define SWJ_CFG_jtag_dp_dis_sw_dp_dis 0x4

/*TODO fill in other remaps*/

/*USART1 remap*/
#define TIM4_REMAP bit12
#define USART1_REMAP bit2

static inline void afio_USART1_enable_remap(void) {
  AFIO->MAPR|=USART1_REMAP;
}

static inline void afio_USART1_disable_remap(void) {
  AFIO->MAPR&=~USART1_REMAP;
}

static inline void afio_TIM4_enable_remap(void) {
  AFIO->MAPR|=TIM4_REMAP;
}

static inline void afio_TIM4_disable_remap(void) {
  AFIO->MAPR&=~TIM4_REMAP;
}


#endif /*AFIO_H*/
