/*                                                                                                                                       
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com>                                                                
 *                                                                                                                                       
 * This program is free software; you can redistribute it and/or modify                                                                  
 * it under the terms of the GNU General Public License as published by                                                                  
 * the Free Software Foundation; either version 3 of the License, or                                                                     
 * (at your option) any later version.                                                                                                   
 *                                                                                                                                       
 * This program is distributed in the hope that it will be useful,                                                                       
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                                                                        
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                                         
 * GNU General Public License for more details.                                                                                          
 *                                                                                                                                       
 * You should have received a copy of the GNU General Public License                                                                     
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.                                                                 
 */

//Cortex-M3 specifics
#ifndef ARM_CM3_H
#define ARM_CM3_H

/*Global enable and disable for interrupts and exceptions
CORE_xxxxGlobalFAULTIRQ is more powerfull than
CORE_xxxxGlobalIRQ
*/
static inline void CORE_enableGlobalFaultIRQ(void) {
    __asm__ volatile ("cpsie f");
}

static inline void CORE_disableGlobalFaultIRQ(void) {
    __asm__ volatile ("cpsid f");
}

static inline void CORE_enableGlobalIRQ(void) {
    __asm__ volatile ("cpsie i");
}

static inline void CORE_disableGlobalIRQ(void) {
    __asm__ volatile ("cpsid i");
}

/* What to put here:

- Specific Exception and interrupt definitions
- Cortex-M3 peripherals
  - Systick timer
- Cortex-M3 registers
*/

//Whether if MPU is present or not is defined in the device.h file
#if MPU==1 //Memory protection unit
//declarations for the MPU
#endif //MPU=="present"

#endif //ARM_CM3_H

