/*                                                                              
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com>       
 *                                                                              
 * This program is free software; you can redistribute it and/or modify         
 * it under the terms of the GNU General Public License as published by         
 * the Free Software Foundation; either version 3 of the License, or            
 * (at your option) any later version.                                          
 *                                                                              
 * This program is distributed in the hope that it will be useful,              
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                
 * GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License            
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        
 */
#include "flash.h"
#include "types.h"
#include "utils.h"

void flash_prefetch_buf_enable(void) {
  FLASH->ACR|=FLASH_PRFTBE;
}
void flash_prefetch_buf_disable(void) {
  FLASH->ACR&=~FLASH_PRFTBE;
}

int flash_latency(flash_lat_t latency) {
  if ((latency>FLASH_latency_two) || (latency<FLASH_latency_zero)) {return(ERROR);};
  writeMultiBitValue(&(FLASH->ACR),latency,FLASH_LATENCY_bit_mask<<FLASH_LATENCY_shift_places,FLASH_LATENCY_shift_places);
  return(SUCCESS);
}
