/*                                                                              
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com>       
 *                                                                              
 * This program is free software; you can redistribute it and/or modify         
 * it under the terms of the GNU General Public License as published by         
 * the Free Software Foundation; either version 3 of the License, or            
 * (at your option) any later version.                                          
 *                                                                              
 * This program is distributed in the hope that it will be useful,              
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                
 * GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License            
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        
 */
#ifndef FLASH_H
#define FLASH_H
#include "mem_map.h"
#include "types.h"
#include <stdint.h>

typedef struct {
  __RW uint32_t ACR;
  __RW uint32_t KEYR;
  __RW uint32_t OPTKEYR;
  __RW uint32_t SR;
  __RW uint32_t CR;
  __RW uint32_t AR;
  __RW uint32_t RESERVED;
  __RW uint32_t OBR;
  __RW uint32_t WRPR;
} flash_t;

typedef enum {
  FLASH_latency_zero=0,
  FLASH_latency_one,
  FLASH_latency_two
} flash_lat_t;

#define FLASH ((flash_t *) FLASH_BASE)

#define FLASH_PRFTBE bit4
#define FLASH_LATENCY_shift_places 0
#define FLASH_LATENCY_bit_mask 0x07

void flash_prefetch_buf_enable(void) ;
void flash_prefetch_buf_disable(void) ;
int flash_latency(flash_lat_t latency);

#endif /*FLASH_H*/
