/*
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "gpio.h"
#include <stdint.h>

/*
uint32_t __gpio_cal_mode(gpio_mode_t* mode) {
    uint32_t tempmode=0x00;
    tempmode=mode->mode;
    if (mode->mode==GPIOM_IN) {
        tempmode|=(mode->inmode<<2);
    } else {
        tempmode|=(mode->outmode<<2);
    }
    return(tempmode);
}
*/

int gpio_set_mode(gpio_t* gpio_port,gpio_mode_t mode, uint16_t pins) {
    if (mode>GPIOM_LAST) return(ERROR);
    uint16_t one=0x1;
    uint8_t shift_places=0;
    for(int i=0;i<16;i++) {
        if (i<8) {
            if ((one & pins)==one) {
	      writeMultiBitValue(&(gpio_port->CRL),(uint32_t) mode, 0x0F<<shift_places, shift_places);
            }
        } else {
            if ((one & pins)==one) {
	      writeMultiBitValue(&(gpio_port->CRH),(uint32_t) mode, 0x0F<<(shift_places-8*4), (shift_places-8*4));
            }
        }
	shift_places+=4;
        one<<=1;
    }
    return(SUCCESS);
}

