/* 
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com> 
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 3 of the License, or 
 * (at your option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 */

/*big memory divisions*/
#define CODE_BASE ((uint32_t)0x0)
#define SRAM_BASE ((uint32_t)0x20000000)
#define PERIPHERAL_BASE ((uint32_t)0x40000000)
#define ESRAM_BASE ((uint32_t)0x60000000)
#define EDEV_BASE ((uint32_t)0xA0000000)
#define PRIV_PERIPHERAL_BUS_BASE ((uint32_t)0xE0000000)
#define VENDOR_MEM_BASE ((uint32_t)0xE0100000

/*code memory*/

/*sram memory*/
#define BBAND_SRAM_BASE (SRAM_BASE)
#define BBAND_ALIAS_SRAM_BASE (SRAM_BASE + 0x02000000)

/*peripheral map*/
#define BBAND_PERI_BASE (PERIPHERAL_BASE)
#define BBAND_ALIAS_PERI_BASE (PERIPHERAL_BASE + 0x02000000)
#define APB1_PERIPHERAL_BASE (PERIPHERAL_BASE)
#define APB2_PERIPHERAL_BASE (PERIPHERAL_BASE + 0x00010000)
#define AHB_PERIPHERAL_BASE (PERIPHERAL_BASE + 0x00018000)

/*APB1 peripheral map*/


/*APB2 peripheral map*/
#define AFIO_BASE (APB2_PERIPHERAL_BASE)
#define EXTI (APB2_PERIPHERAL_BASE + 0x00000400)
/*GPIOs map*/
#define GPIOA_BASE (APB2_PERIPHERAL_BASE + 0x00000800)
#define GPIOB_BASE (APB2_PERIPHERAL_BASE + 0x00000C00)
#define GPIOC_BASE (APB2_PERIPHERAL_BASE + 0x00001000)
#define GPIOD_BASE (APB2_PERIPHERAL_BASE + 0x00001400)
#define GPIOE_BASE (APB2_PERIPHERAL_BASE + 0x00001800)
#define GPIOF_BASE (APB2_PERIPHERAL_BASE + 0x00001C00)
#define GPIOG_BASE (APB2_PERIPHERAL_BASE + 0x00002000)
/*ADC map*/
#define ADC1_BASE (APB2_PERIPHERAL_BASE + 0x00002400)
#define ADC2_BASE (APB2_PERIPHERAL_BASE + 0x00002800)
#define ADC3_BASE (APB2_PERIPHERAL_BASE + 0x00003C00)
/*Advanced timers map*/
#define TIM1_BASE (APB2_PERIPHERAL_BASE + 0x00002C00)
#define TIM8_BASE (APB2_PERIPHERAL_BASE + 0x00003400)
/*SPI map*/
#define SPI1_BASE (APB2_PERIPHERAL_BASE + 0x00003000)
/*USART map*/
#define USART1_BASE (APB2_PERIPHERAL_BASE + 0x00003800)


/*AHB peripheral map*/
#define RCC_BASE (AHB_PERIPHERAL_BASE + 0x00009000)
#define FLASH_BASE (AHB_PERIPHERAL_BASE + 0x0000A000)

/*Private peripheral bus*/
#define PRIV_PERIPHERAL_BUS_INTERNAL_BASE (PRIV_PERIPHERAL_BUS_BASE)
#define PRIV_PERIPHERAL_BUS_EXTERNAL_BASE (PRIV_PERIPHERAL_BUS_BASE + 0x00040000)

/*Private peripheral bus internal*/
#define ITM_BASE (PRIV_PERIPHERAL_BUS_INTERNAL_BASE)
#define DWT_BASE (PRIV_PERIPHERAL_BUS_INTERNAL_BASE + 0x00001000)
#define FPB_BASE (PRIV_PERIPHERAL_BUS_INTERNAL_BASE + 0x00002000)
#define NVIC_BASE (PRIV_PERIPHERAL_BUS_INTERNAL_BASE + 0x0000E000)

/*Private peripheral bus external*/
#define TPIU_BASE (PRIV_PERIPHERAL_BUS_EXTERNAL_BASE)
#define ETM_BASE (PRIV_PERIPHERAL_BUS_EXTERNAL_BASE + 0x00001000)
#define EXT_PPB_BASE (PRIV_PERIPHERAL_BUS_EXTERNAL_BASE + 0x00002000)
#define ROM_TABLE_BASE (PRIV_PERIPHERAL_BUS_EXTERNAL_BASE + 0x000BF000)

