/*              
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com>
 *                
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *                                                  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.                                       
 *                      
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

//stm32f103 medium density devices
#ifndef STM32F103
#define STM32F103

typedef enum IRQn {
    NonMaskableInt_IRQn=-14,
    HardFault_IRQn=-13,
    MemoryManagement_IRQn=-12,
    BusFault_IRQn=-11,
    UsageFault_IRQn=-10,
    SVCall_IRQn=-5,
    DebugMonitor_IRQn=-4,
    PendSV_IRQn=-2,
    SysTick_IRQn=-1,
    wwdg_irq_IRQn=0,
    pvd_irq_IRQn,
    tamper_irq_IRQn,
    rtc_irq_IRQn  ,
    flash_irq_IRQn  ,
    rcc_irq_IRQn  ,
    exti0_irq_IRQn  ,
    exti1_irq_IRQn  ,
    exti2_irq_IRQn  ,
    exti3_irq_IRQn  ,
    exti4_irq_IRQn  ,
    dma1_channel1_irq_IRQn  ,
    dma1_channel2_irq_IRQn  ,
    dma1_channel3_irq_IRQn  ,
    dma1_channel4_irq_IRQn  ,
    dma1_channel5_irq_IRQn  ,
    dma1_channel6_irq_IRQn  ,
    dma1_channel7_irq_IRQn  ,
    adc1_2_irq_IRQn  ,
    usb_hp_can_tx_irq_IRQn  ,
    usb_lp_can1_rx0_irq_IRQn  ,
    can_rx1_irq_IRQn  ,
    can_sce_irq_IRQn  ,
    exti9_5_irq_IRQn  ,
    tim1_brk_irq_IRQn  ,
    tim1_up_irq_IRQn  ,
    tim1_trg_com_irq_IRQn  ,
    tim1_cc_irq_IRQn  ,
    tim2_irq_IRQn  ,
    tim3_irq_IRQn  ,
    tim4_irq_IRQn  ,
    i2c1_ev_irq_IRQn  ,
    i2c1_er_irq_IRQn  ,
    i2c2_ev_irq_IRQn  ,
    i2c2_er_irq_IRQn  ,
    spi1_irq_IRQn  ,
    spi2_irq_IRQn  ,
    usart1_irq_IRQn  ,
    usart2_irq_IRQn  ,
    usart3_irq_IRQn  ,
    exti15_10_irq_IRQn  ,
    rtc_alarm_irq_IRQn  ,
    usb_wake_up_irq_IRQn  ,
    tim8_brk_irq_IRQn  ,
    tim8_up_irq_IRQn  ,
    tim8_trg_com_irq_IRQn  ,
    tim8_cc_irq_IRQn  ,
    adc3_irq_IRQn  ,
    fsmc_irq_IRQn  ,
    sdio_irq_IRQn  ,
    tim5_irq_IRQn  ,
    spi3_irq_IRQn  ,
    uart4_irq_IRQn  ,
    uart5_irq_IRQn  ,
    tim6_irq_IRQn  ,
    tim7_irq_IRQn  ,
    dma2_channel1_irq_IRQn  ,
    dma2_channel2_irq_IRQn  ,
    dma2_channel3_irq_IRQn  ,
    dma2_channel4_5_irq_IRQn  ,
} irq_t;

#define __NVIC_PRIO_BITS 4 //16 priority levels

/* What to put here:
- Specific interrupt definitions
- Device peripheral includes
*/
#endif //STM32F103
