/*              
 * Copyright (C) 2009 by Federico Ruiz-Ugalde <memeruiz at gmail dot com>
 *                
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *                                                  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.                                       
 *                      
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "utils.h"
#include "types.h"

int writeMultiBitValue(__RW uint32_t * mem_reg, uint32_t value, uint32_t bits, uint8_t shift_places) {
    uint32_t temp;
    uint32_t outvalue=(value<<shift_places);
    if (outvalue>bits) {
        return(ERROR);
    }
    temp=*mem_reg;
    temp&=~bits;
    *mem_reg=temp|outvalue;
    return(SUCCESS);
}

bool get_flagStatus(__RW uint32_t * mem_reg, uint32_t flag) {
    if ((*mem_reg&flag)==0) {
        return(false);
    } else {
        return(true);
    }
}

void set_bit(__RW uint32_t * mem_reg, uint32_t bit, bool value) {
  if (value) {
    *mem_reg|=bit;
  } else {
    *mem_reg&=~bit;
  }
}

int detect_shift_places(uint32_t data) {
  int shift_places=0;
  while ((data&0x01) == 0x0) {
    data=data>>1;
    shift_places+=1;
  }
  return(shift_places);
}
