/*
 * Open-BLDC - Open BruschLess DC Motor Controller
 * Copyright (C) 2009 by Piotr Esden-Tempski <piotr@esden.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stm32/usb/lib.h>

#include "usb_conf.h"
#include "usb_desc.h"

#include "usb_endp.h"

uint8_t buffer_out[VIRTUAL_COM_PORT_DATA_SIZE];
uint8_t buffer_in[VIRTUAL_COM_PORT_DATA_SIZE];
__IO uint32_t count_out = 0;
uint32_t count_in = 0;

void EP3_OUT_Callback(void){
    static uint8_t on = 0;
    if(on){
        //turn the status led on
        GPIOC->BSRR |= 0x00001000;
        on = 0;
    }else{
        //turn the status led off
        GPIOC->BRR |= 0x00001000;
        on = 1;
    }
    //Get the number of bytes waiting to get read out
    count_out = GetEPRxCount(ENDP3);
    //copy the bytes to buffer_out
    PMAToUserBufferCopy(buffer_out, ENDP3_RXADDR, count_out);
    //mark the endpoint buffer as read
    SetEPRxValid(ENDP3);

    //here we can change the buffer_out, for the answer
    if (buffer_out[0]=='x') {
        buffer_out[0]='y';
    }

    //buffer_in[0]='a';
    //buffer_in[1]='b';
    //count_in=2;

    //UserToPMABufferCopy(buffer_in, ENDP1_TXADDR, count_in);
    //set the number of bytes to be sent out
    //SetEPTxCount(ENDP1, count_in);
    //mark the endpoint as ready
    //SetEPTxValid(ENDP1);
}

void EP1_IN_Callback(void){
  count_in = 0;
}

